frontend: add armv6 color space converter
[pcsx_rearmed.git] / configure
... / ...
CommitLineData
1#!/bin/sh
2# some elements originated from qemu configure
3set -e
4
5TMPC="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}.c"
6TMPO="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}.o"
7TMPB="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}"
8trap "rm -f $TMPC $TMPO $TMPB" EXIT INT QUIT TERM
9rm -f config.log
10
11compile_object()
12{
13 c="$CC $CFLAGS -c $TMPC -o $TMPO $@"
14 echo $c >> config.log
15 $c >> config.log 2>&1
16}
17
18compile_binary()
19{
20 c="$CC $CFLAGS $TMPC -o $TMPB $LDFLAGS $MAIN_LDLIBS $@"
21 echo $c >> config.log
22 $c >> config.log 2>&1
23}
24
25check_define()
26{
27 $CC -E -dD $CFLAGS include/arm_features.h | grep -q $1 || return 1
28 return 0
29}
30
31# setting options to "yes" or "no" will make that choice default,
32# "" means "autodetect".
33
34platform_list="generic pandora maemo caanoo libretro"
35platform="generic"
36builtin_gpu_list="peops unai neon"
37builtin_gpu=""
38sound_driver_list="oss alsa pulseaudio sdl libretro"
39sound_drivers=""
40plugins="plugins/spunull/spunull.so \
41plugins/dfxvideo/gpu_peops.so plugins/gpu_unai/gpu_unai.so"
42ram_fixed="no"
43drc_cache_base="no"
44have_armv5=""
45have_armv6=""
46have_armv7=""
47have_arm_neon=""
48have_tslib=""
49have_gles=""
50enable_dynarec="yes"
51need_sdl="no"
52need_xlib="no"
53need_libpicofe="yes"
54need_warm="no"
55CFLAGS_GLES=""
56LDLIBS_GLES=""
57# these are for known platforms
58optimize_cortexa8="no"
59optimize_arm926ej="no"
60
61# hardcoded stuff
62CC="${CC-${CROSS_COMPILE}gcc}"
63CXX="${CXX-${CROSS_COMPILE}g++}"
64AS="${AS-${CROSS_COMPILE}as}"
65AR="${AS-${CROSS_COMPILE}ar}"
66MAIN_LDLIBS="$LDLIBS -ldl -lm"
67config_mak="config.mak"
68
69fail()
70{
71 echo "$@"
72 exit 1
73}
74
75# call during arg parsing, so that cmd line can override platform defaults
76set_platform()
77{
78 platform=$1
79 case "$platform" in
80 generic)
81 ;;
82 pandora)
83 sound_drivers="oss alsa"
84 ram_fixed="yes"
85 drc_cache_base="yes"
86 optimize_cortexa8="yes"
87 have_arm_neon="yes"
88 need_xlib="yes"
89 ;;
90 maemo)
91 ram_fixed="yes"
92 drc_cache_base="yes"
93 optimize_cortexa8="yes"
94 have_arm_neon="yes"
95 ;;
96 caanoo)
97 sound_drivers="oss"
98 ram_fixed="yes"
99 drc_cache_base="yes"
100 optimize_arm926ej="yes"
101 need_warm="yes"
102 ;;
103 libretro)
104 sound_drivers="libretro"
105 need_libpicofe="no"
106 ;;
107 *)
108 fail "unsupported platform: $platform"
109 ;;
110 esac
111}
112
113for opt do
114 optarg=`expr "x$opt" : 'x[^=]*=\(.*\)'` || true
115 case "$opt" in
116 --help|-h) show_help="yes"
117 ;;
118 --platform=*) set_platform "$optarg"
119 ;;
120 --gpu=*) builtin_gpu="$optarg"
121 ;;
122 --sound-drivers=*) sound_drivers="$optarg"
123 ;;
124 --enable-neon) have_arm_neon="yes"
125 ;;
126 --disable-neon) have_arm_neon="no"
127 ;;
128 --disable-dynarec) enable_dynarec="no"
129 ;;
130 *) echo "ERROR: unknown option $opt"; show_help="yes"
131 ;;
132 esac
133done
134
135if [ "$show_help" = "yes" ]; then
136 echo "options:"
137 echo " --help print this message"
138 echo " --platform=NAME target platform [$platform]"
139 echo " available: $platform_list"
140 echo " --gpu=NAME builtin gpu plugin [guessed]"
141 echo " available: $builtin_gpu_list"
142 echo " --sound-drivers=LIST sound output drivers [guessed]"
143 echo " available: $sound_driver_list"
144 echo " --enable-neon"
145 echo " --disable-neon enable/disable ARM NEON optimizations [guessed]"
146 echo " --disable-dynarec disable dynamic recompiler"
147 echo " (dynarec is only available and enabled on ARM)"
148 echo "influential environment variables:"
149 echo " CROSS_COMPILE CC CXX AS AR CFLAGS ASFLAGS LDFLAGS LDLIBS"
150 exit 1
151fi
152
153# validate selections
154if [ "x$builtin_gpu" != "x" ]; then
155 if ! echo $builtin_gpu_list | grep -q "\<$builtin_gpu\>"; then
156 fail "unsupported builtin gpu plugin: $builtin_gpu"
157 fi
158fi
159
160if [ "x$sound_drivers" != "x" ]; then
161 for d in $sound_drivers; do
162 if ! echo $sound_driver_list | grep -q "\<$d\>"; then
163 fail "unsupported sound driver: $sound_driver"
164 fi
165 done
166fi
167
168if [ "$need_libpicofe" = "yes" ]; then
169 if ! test -f "frontend/libpicofe/README"; then
170 fail "libpicofe is missing, please run 'git submodule init && git submodule update'"
171 fi
172fi
173
174if [ "$need_warm" = "yes" ]; then
175 if ! test -f "frontend/warm/README"; then
176 fail "wARM is missing, please run 'git submodule init && git submodule update'"
177 fi
178fi
179
180# basic compiler test
181cat > $TMPC <<EOF
182#include <zlib.h>
183int main(void) { return 0; }
184EOF
185if ! compile_binary; then
186 fail "compiler test failed, please check config.log"
187fi
188
189if [ -z "$ARCH" ]; then
190 ARCH=`$CC -dumpmachine | awk -F '-' '{print $1}'`
191fi
192
193case "$ARCH" in
194arm*)
195 # ARM stuff
196 ARCH="arm"
197
198 if [ "$optimize_cortexa8" = "yes" ]; then
199 CFLAGS="$CFLAGS -mcpu=cortex-a8 -mtune=cortex-a8"
200 ASFLAGS="$ASFLAGS -mcpu=cortex-a8"
201 fi
202 if [ "$optimize_arm926ej" = "yes" ]; then
203 CFLAGS="$CFLAGS -mcpu=arm926ej-s -mtune=arm926ej-s"
204 ASFLAGS="$ASFLAGS -mcpu=arm926ej-s -mfloat-abi=softfp"
205 fi
206
207 if [ "x$have_arm_neon" = "x" ]; then
208 # detect NEON from user-supplied cflags to enable asm code
209 have_arm_neon=`check_define __ARM_NEON__ && echo yes` || true
210 fi
211 if [ "x$have_armv7" = "x" ]; then
212 if check_define HAVE_ARMV7; then
213 have_armv7="yes"
214 have_armv6="yes"
215 have_armv5="yes"
216 fi
217 fi
218 if [ "x$have_armv6" = "x" ]; then
219 if check_define HAVE_ARMV6; then
220 have_armv6="yes"
221 have_armv5="yes"
222 fi
223 fi
224 if [ "x$have_armv5" = "x" ]; then
225 have_armv5=`check_define HAVE_ARMV5 && echo yes` || true
226 fi
227
228 if [ "x$builtin_gpu" = "x" ]; then
229 if [ "$have_arm_neon" = "yes" ]; then
230 builtin_gpu="neon"
231 elif [ "$have_armv7" != "yes" ]; then
232 # pre-ARMv7 hardware is usually not fast enough for peops
233 builtin_gpu="unai"
234 else
235 builtin_gpu="peops"
236 fi
237 fi
238
239 # automatically set mfpu and mfloat-abi if they are not set
240 if [ "$have_arm_neon" = "yes" ]; then
241 fpu="neon"
242 elif [ "$have_armv6" = "yes" ]; then
243 fpu="vfp"
244 fi
245 if [ "x$fpu" != "x" ]; then
246 echo "$CFLAGS" | grep -q -- '-mfpu=' || CFLAGS="$CFLAGS -mfpu=$fpu"
247 echo "$ASFLAGS" | grep -q -- '-mfpu=' || ASFLAGS="$ASFLAGS -mfpu=$fpu"
248 floatabi_set_by_gcc=`$CC -v 2>&1 | grep -q -- --with-float= && echo yes` || true
249 if [ "$floatabi_set_by_gcc" != "yes" ]; then
250 echo "$CFLAGS" | grep -q -- '-mfloat-abi=' || CFLAGS="$CFLAGS -mfloat-abi=softfp"
251 echo "$ASFLAGS" | grep -q -- '-mfloat-abi=' || ASFLAGS="$ASFLAGS -mfloat-abi=softfp"
252 fi
253 fi
254
255 # must disable thumb as recompiler can't handle it
256 if check_define __thumb__; then
257 CFLAGS="$CFLAGS -marm"
258 fi
259
260 # warn about common mistakes
261 if [ "$have_armv5" != "yes" ]; then
262 if ! echo "$CFLAGS" | grep -q -- '-mcpu=\|-march='; then
263 echo "Warning: compiling for ARMv4, is that really what you want?"
264 echo "You probably should specify -mcpu= or -march= like this:"
265 echo " CFLAGS=-march=armv6 ./configure ..."
266 fi
267 fi
268 if [ "$have_arm_neon" = "yes" -a "$have_armv7" != "yes" ]; then
269 echo "Warning: compiling for NEON, but not ARMv7?"
270 echo "You probably want to specify -mcpu= or -march= like this:"
271 echo " CFLAGS=-march=armv7-a ./configure ..."
272 fi
273 ;;
274*)
275 # dynarec only available on ARM
276 enable_dynarec="no"
277 ;;
278esac
279
280if [ "x$builtin_gpu" = "x" ]; then
281 builtin_gpu="peops"
282fi
283
284# supposedly we can avoid -fPIC on armv5 for slightly better performace?
285if [ "$ARCH" != "arm" -o "$have_armv6" = "yes" ]; then
286 PLUGIN_CFLAGS="$PLUGIN_CFLAGS -fPIC"
287fi
288
289if [ "$ram_fixed" = "yes" ]; then
290 CFLAGS="$CFLAGS -DRAM_FIXED"
291fi
292
293case "$platform" in
294generic)
295 need_sdl="yes"
296 ;;
297maemo)
298 maemo_cflags=`pkg-config --cflags hildon-1`
299 maemo_ldlibs=`pkg-config --libs hildon-1`
300 CFLAGS="$CFLAGS -DMAEMO -DMAEMO_CHANGES $maemo_cflags"
301 MAIN_LDLIBS="$MAIN_LDLIBS $maemo_ldlibs"
302 ;;
303libretro)
304 CFLAGS="$CFLAGS -fPIC"
305 MAIN_LDFLAGS="$MAIN_LDFLAGS -shared -Wl,--no-undefined"
306 ;;
307esac
308
309# header/library presence tests
310check_zlib()
311{
312 cat > $TMPC <<EOF
313 #include <zlib.h>
314 int main(void) { uncompress(0, 0, 0, 0); }
315EOF
316 compile_binary
317}
318
319check_libpng()
320{
321 cat > $TMPC <<EOF
322 #include <png.h>
323 void main() { png_init_io(0, 0); }
324EOF
325 compile_binary
326}
327
328check_oss()
329{
330 cat > $TMPC <<EOF
331 #include <sys/soundcard.h>
332 #include <sys/ioctl.h>
333 void main() { int a=0; ioctl(0, SNDCTL_DSP_SETFMT, &a); }
334EOF
335 compile_binary
336}
337
338check_alsa()
339{
340 cat > $TMPC <<EOF
341 #include <alsa/asoundlib.h>
342 void main() { snd_pcm_open(0, 0, 0, 0); }
343EOF
344 compile_binary "$@"
345}
346
347check_pulseaudio()
348{
349 cat > $TMPC <<EOF
350 #include <pulse/pulseaudio.h>
351 void main() { pa_threaded_mainloop_new(); }
352EOF
353 compile_binary "$@"
354}
355
356check_sdl()
357{
358 cat > $TMPC <<EOF
359 #include <SDL.h>
360 void main() { SDL_OpenAudio(0, 0); }
361EOF
362 compile_binary "$@"
363}
364
365check_xlib_headers()
366{
367 cat > $TMPC <<EOF
368 #include <X11/Xlib.h>
369 void *f() { return XOpenDisplay(0); }
370EOF
371 compile_object "$@"
372}
373
374MAIN_LDLIBS="$MAIN_LDLIBS -lz"
375check_zlib || fail "please install zlib (libz-dev)"
376
377MAIN_LDLIBS="-lpng $MAIN_LDLIBS"
378check_libpng || fail "please install libpng (libpng-dev)"
379
380# find what audio support we can compile
381if [ "x$sound_drivers" = "x" ]; then
382 if check_oss; then sound_drivers="$sound_drivers oss"; fi
383 if check_alsa -lasound; then
384 sound_drivers="$sound_drivers alsa"
385 MAIN_LDLIBS="-lasound $MAIN_LDLIBS"
386 fi
387 if check_pulseaudio -lpulse; then
388 sound_drivers="$sound_drivers pulseaudio"
389 MAIN_LDLIBS="-lpulse $MAIN_LDLIBS"
390 fi
391 if [ "$need_sdl" = "yes" ] || check_sdl `sdl-config --cflags --libs`; then
392 sound_drivers="$sound_drivers sdl"
393 need_sdl="yes"
394 fi
395else
396 if echo $sound_drivers | grep -q "\<oss\>"; then
397 check_oss || fail "oss support is missing"
398 fi
399 if echo $sound_drivers | grep -q "\<alsa\>"; then
400 MAIN_LDLIBS="-lasound $MAIN_LDLIBS"
401 check_alsa || fail "please install libasound2-dev"
402 fi
403 if echo $sound_drivers | grep -q "\<pulseaudio\>"; then
404 MAIN_LDLIBS="-lpulse $MAIN_LDLIBS"
405 check_pulseaudio || fail "pulseaudio support is missing"
406 fi
407fi
408
409if [ "$need_sdl" = "yes" ]; then
410 which sdl-config > /dev/null || \
411 fail "sdl-config is missing; please install libsdl (libsdl1.2-dev)"
412 CFLAGS="$CFLAGS `sdl-config --cflags`"
413 MAIN_LDLIBS="`sdl-config --libs` $MAIN_LDLIBS"
414 check_sdl || fail "please install libsdl (libsdl1.2-dev)"
415fi
416
417# check for tslib (only headers needed)
418if [ "x$have_tslib" = "x" ]; then
419 cat > $TMPC <<EOF
420 #include <tslib.h>
421 void test(struct ts_sample sample) {}
422EOF
423 if compile_object; then
424 have_tslib="yes"
425 else
426 have_tslib="no"
427 fi
428fi
429
430# check for VideoCore stuff for Raspberry Pi
431if [ -d /opt/vc/include -a -d /opt/vc/lib ]; then
432 CFLAGS_GLES="$CFLAGS_GLES -I/opt/vc/include -I/opt/vc/include/interface/vcos/pthreads"
433 LDLIBS_GLES="$LDLIBS_GLES -L/opt/vc/lib"
434 need_xlib="yes"
435fi
436
437# check for GLES headers
438cat > $TMPC <<EOF
439#include <GLES/gl.h>
440#include <EGL/egl.h>
441int main(void) {
442 return (int)eglGetDisplay( (EGLNativeDisplayType)0 );
443}
444EOF
445if compile_binary $CFLAGS_GLES -lEGL -lGLES_CM $LDLIBS_GLES; then
446 have_gles="yes"
447 LDLIBS_GLES="-lEGL -lGLES_CM $LDLIBS_GLES"
448elif compile_binary $CFLAGS_GLES -lEGL -lGLESv1_CM $LDLIBS_GLES; then
449 have_gles="yes"
450 LDLIBS_GLES="-lEGL -lGLESv1_CM $LDLIBS_GLES"
451fi
452
453if [ "$have_gles" = "yes" ]; then
454 plugins="$plugins plugins/gpu-gles/gpu_gles.so"
455fi
456if [ "$have_arm_neon" = "yes" -a "$builtin_gpu" != "neon" ]; then
457 plugins="$plugins plugins/gpu_neon/gpu_neon.so"
458fi
459
460# check for xlib (only headers needed)
461if [ "x$need_xlib" = "xyes" ]; then
462 check_xlib_headers || fail "please install libx11-dev"
463fi
464
465cat > $TMPC <<EOF
466void test(void *f, void *d) { fread(d, 1, 1, f); }
467EOF
468if compile_object -Wno-unused-result; then
469 CFLAGS="$CFLAGS -Wno-unused-result"
470fi
471
472# short plugin list for display
473for p in $plugins; do
474 p1=`basename $p`
475 plugins_short="$p1 $plugins_short"
476done
477
478# set things that failed to autodetect to "no"
479test "x$have_armv6" != "x" || have_armv6="no"
480test "x$have_armv7" != "x" || have_armv7="no"
481test "x$have_arm_neon" != "x" || have_arm_neon="no"
482test "x$have_gles" != "x" || have_gles="no"
483
484echo "architecture $ARCH"
485echo "platform $platform"
486echo "built-in GPU $builtin_gpu"
487echo "sound drivers $sound_drivers"
488echo "plugins $plugins_short"
489echo "C compiler $CC"
490echo "C compiler flags $CFLAGS"
491echo "libraries $MAIN_LDLIBS"
492echo "linker flags $LDFLAGS$MAIN_LDFLAGS"
493echo "enable dynarec $enable_dynarec"
494echo "ARMv7 optimizations $have_armv7"
495echo "enable ARM NEON $have_arm_neon"
496echo "tslib support $have_tslib"
497if [ "$platform" = "generic" ]; then
498 echo "OpenGL ES output $have_gles"
499fi
500
501echo "# Automatically generated by configure" > $config_mak
502printf "# Configured with:" >> $config_mak
503printf " '%s'" "$0" "$@" >> $config_mak
504echo >> $config_mak
505
506echo "CC = $CC" >> $config_mak
507echo "CXX = $CXX" >> $config_mak
508echo "AS = $AS" >> $config_mak
509echo "CFLAGS += $CFLAGS" >> $config_mak
510echo "ASFLAGS += $ASFLAGS" >> $config_mak
511echo "LDFLAGS += $LDFLAGS" >> $config_mak
512echo "MAIN_LDFLAGS += $MAIN_LDFLAGS" >> $config_mak
513echo "MAIN_LDLIBS += $MAIN_LDLIBS" >> $config_mak
514echo "PLUGIN_CFLAGS += $PLUGIN_CFLAGS" >> $config_mak
515echo >> $config_mak
516
517if [ "$platform" = "libretro" ]; then
518 echo "TARGET = libretro.so" >> $config_mak
519fi
520echo "ARCH = $ARCH" >> $config_mak
521echo "PLATFORM = $platform" >> $config_mak
522echo "BUILTIN_GPU = $builtin_gpu" >> $config_mak
523echo "SOUND_DRIVERS = $sound_drivers" >> $config_mak
524echo "PLUGINS = $plugins" >> $config_mak
525if [ "$have_arm_neon" = "yes" ]; then
526 echo "HAVE_NEON = 1" >> $config_mak
527fi
528if [ "$have_tslib" = "yes" ]; then
529 echo "HAVE_TSLIB = 1" >> $config_mak
530fi
531if [ "$have_gles" = "yes" ]; then
532 echo "HAVE_GLES = 1" >> $config_mak
533 echo "CFLAGS_GLES = $CFLAGS_GLES" >> $config_mak
534 echo "LDLIBS_GLES = $LDLIBS_GLES" >> $config_mak
535fi
536if [ "$enable_dynarec" = "yes" ]; then
537 echo "USE_DYNAREC = 1" >> $config_mak
538fi
539if [ "$drc_cache_base" = "yes" ]; then
540 echo "DRC_CACHE_BASE = 1" >> $config_mak
541fi
542
543# use pandora's skin (for now)
544test -e skin || ln -s frontend/pandora/skin skin
545
546# vim:shiftwidth=2:expandtab